﻿
Partial Class Form1

    Inherits System.Windows.Forms.Form

    ' ###############################################################################################
    ' ###############################################################################################
    ' ###############################################################################################
    ' 
    '   SCROLL BOX
    ' 
    ' ###############################################################################################
    ' ###############################################################################################
    ' ###############################################################################################
    Private ScrollBox_Graphics As Graphics
    Private ScrollBox_Cursor_Height As Int32
    Private ScrollBox_Cursor_Brush As New SolidBrush(Color.FromArgb(255, 200, 100))
    Private ScrollBox_Cursor_Pen As New Pen(Color.FromArgb(255, 200, 100), 4)

    Friend Sub ScrollBox_Paint()
        ' ----------------------------------------------------------------------
        RTB_Lines = RTB.Lines
        If RTB_Lines.Length = 0 Then Return
        ' ----------------------------------------------------------------------
        ScrollBox.Left = RTB.Right - 19
        ScrollBox.Width = 17
        ScrollBox.Top = RTB.Top + 4
        ScrollBox.Height = RTB.Height - 6
        ScrollBox_Graphics = InitPictureboxImageAndGraphics(ScrollBox)
        ScrollBox_Graphics.Clear(Color.WhiteSmoke)
        ' ----------------------------------------------------------------------
        Dim PageLines As Int32 = CInt(RTB.ClientSize.Height / _
                                      (RTB.Font.GetHeight() * RTB.ZoomFactor))
        Dim k1 As Double = RTB_Lines.Length / PageLines
        If k1 < 1 Then k1 = 1
        '
        ScrollBox_Cursor_Height = CInt(ScrollBox.Height / k1)
        ScrollBox_Cursor_Height = Math.Max(ScrollBox_Cursor_Height, 20)
        ' ----------------------------------------------------------------------
        Dim y As Double = 0
        If RTB_Lines.Length > PageLines Then
            y = (ScrollBox.Height - ScrollBox_Cursor_Height) * RTB.GetFirstVisibleLine / (RTB_Lines.Length - PageLines)
        End If
        ' ----------------------------------------------------------------------
        ScrollBox_Graphics.FillRectangle(Brushes.LightGoldenrodYellow, _
                                         1, CInt(y), ScrollBox.Width, ScrollBox_Cursor_Height)
        ScrollBox_Graphics.DrawRectangle(ScrollBox_Cursor_Pen, _
                                         3, CInt(y) + 2, ScrollBox.Width - 5, ScrollBox_Cursor_Height - 4)
        ' ----------------------------------------------------------------------
        If Running Then
            ScrollBox_AddBookMarkLinesInfo()
            ScrollBox_AddRunningInfo()
        Else
            ScrollBox_AddBookMarkLinesInfo()
            ScrollBox_AddEditedLinesInfo()
            ScrollBox_AddFindInfo()
        End If
        ' ----------------------------------------------------------------------
        If IsVerticalScrollBarVisible(RTB.Handle) Then
            ScrollBox.Visible = True
            ScrollBox.Refresh()
        Else
            ScrollBox.Visible = False
        End If
    End Sub

    ' ===========================================================================================
    '  SCROLL BOX - MOUSE EVENTS
    ' ===========================================================================================
    Private Sub ScrollBox_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs) Handles ScrollBox.MouseMove
        If e.Button <> MouseButtons.Left Then Return
        If ScrollBox_Cursor_Height >= ScrollBox.Height Then Return
        RTB_Lines = RTB.Lines
        '
        Dim mousey2 As Int32 = e.Y - ScrollBox_Cursor_Height \ 2
        Dim y2 As Int32 = mousey2 * GetScrollYmax(RTB.Handle) \ GetScrollNpage(RTB.Handle)
        SetScrollPosY(RTB.Handle, y2)
        '
        'Debug.Print(y.ToString + " " + y3.ToString + " " + y4.ToString)
        'Debug.Print(y.ToString + " " + y2.ToString)
    End Sub

    Private Sub ScrollBox_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ScrollBox.MouseWheel
        If ScrollBox_Cursor_Height >= ScrollBox.Height Then Return
        RTB_Lines = RTB.Lines
        Dim delta As Int32 = e.Delta * RTB_Lines.Length \ 80
        Dim y As Int32 = GetScrollPosY(RTB.Handle)
        SetScrollPosY(RTB.Handle, y - delta)
    End Sub

    ' ===========================================================================================
    '  SCROLL BOX EVENTS
    ' ===========================================================================================
    Private Sub ScrollBox_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs) Handles ScrollBox.MouseDown
        '
    End Sub
    Private Sub ScrollBox_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ScrollBox.MouseUp
        '
    End Sub
    Private Sub RTB_VScroll(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTB.VScroll
        '
    End Sub
    Private Sub RTB_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTB.Resize
        '
    End Sub

    ' ===========================================================================================
    '  SCROLL BOX - RUNNING INFO
    ' ===========================================================================================
    Private ScrollBox_LineInExecution_Brush As New SolidBrush(Color.FromArgb(120, 0, 0, 255))

    Private Sub ScrollBox_AddRunningInfo()
        If RTB.ExecutedLines.Length = 0 Then Return
        Dim y As Int32
        ' ------------------------------------------------------------- Red markers (executed lines)
        For i As Int32 = 0 To RTB.ExecutedLines.Length - 1
            Dim n As Single = RTB.ExecutedLines(i)
            If n > 0 Then
                ' -------------------------------------------------------- COLOR
                n = n * n
                Dim r As Int32 = CInt(220 + n * 35)  ' was 35
                Dim g As Int32 = CInt(225 - n * 200) ' was 80 120  
                Dim b As Int32 = CInt(225 - n * 225) ' was 225 200 
                Dim br1 As New SolidBrush(Color.FromArgb(120, r, g, b))
                ' -------------------------------------------------------- Y position
                y = ScrollBox.Height * i \ RTB.ExecutedLines.Length
                ' -------------------------------------------------------- 
                ScrollBox_Graphics.FillEllipse(br1, 2 + 3, y - 4, 15 - 3, 9)
            End If
        Next
        ' ------------------------------------------------------------------ Blue Marker (line in execution)
        y = ScrollBox.Height * LineInExecution \ RTB.ExecutedLines.Length
        ScrollBox_Graphics.FillEllipse(ScrollBox_LineInExecution_Brush, 2 + 3, y - 5, 11, 11)
    End Sub

    ' ===========================================================================================
    '  SCROLL BOX - FIND INFO
    ' ===========================================================================================
    Friend ScrollBox_WordToFind As String = ""

    Friend Sub ScrollBox_SetWordToFind(ByVal s As String)
        If s <> ScrollBox_WordToFind Then
            ScrollBox_WordToFind = s.Trim
            RTB.Refresh()
        End If
    End Sub

    Private AddFindInfoBrush1 As New SolidBrush(Color.FromArgb(110, 210, 0))
    Private AddFindInfoBrush2 As New SolidBrush(Color.FromArgb(130, 240, 100))
    Friend Sub ScrollBox_AddFindInfo()
        If RTB_Lines Is Nothing OrElse RTB_Lines.Length = 0 Then Return
        If ScrollBox_WordToFind = "" Then Return
        For i As Int32 = 0 To RTB_Lines.Length - 1
            If EventStopLabelExecuted Then Return
            If RTB_Lines(i).IndexOf(ScrollBox_WordToFind, StringComparison.CurrentCultureIgnoreCase) >= 0 Then
                Dim y As Int32 = ScrollBox.Height * i \ RTB_Lines.Length
                ScrollBox_Graphics.FillEllipse(AddFindInfoBrush1, 3, y - 3, 11, 7)
                RTB.HilightFindInfoLine(i, AddFindInfoBrush2)
            End If
        Next
    End Sub

    ' ===========================================================================================
    '  SCROLL BOX - EDITED LINES INFO
    ' ===========================================================================================
    Private Structure ScrollBox_EditedLine
        Dim LineNumber As Int32
        Dim LifeCounter As Int32
    End Structure
    Private ScrollBox_EditedLines(-1) As ScrollBox_EditedLine

    Friend Sub ScrollBox_AddEditedLinesFromFile(ByVal s As String)
        s = s.Trim
        If s = "" Then
            ReDim ScrollBox_EditedLines(-1)
            Return
        End If
        Dim sa() As String = s.Split(" "c)
        ' ------------------------------------------------ add edited lines
        ReDim ScrollBox_EditedLines(sa.Length \ 2 - 1)
        For i As Int32 = 0 To sa.Length - 1 Step 2
            ScrollBox_EditedLines(i \ 2).LineNumber = CInt(Val(sa(i)))
            ScrollBox_EditedLines(i \ 2).LifeCounter = CInt(Val(sa(i + 1)))
        Next
        ' ------------------------------------------------ remove edited line after the last line
        For n As Int32 = 0 To ScrollBox_EditedLines.Length - 1
            If ScrollBox_EditedLines(n).LineNumber < 0 Or _
               ScrollBox_EditedLines(n).LineNumber >= RTB_Lines.Length Then
                ScrollBox_EditedLines(n).LifeCounter = 0
            End If
        Next
        ScrollBox_RemoveEditedLinesWithZeroLife()
    End Sub

    Friend Function ScrollBox_EditedLinesToString() As String
        Dim s As String = vbCrLf + "'EDITEDLINES "
        For i As Int32 = 0 To ScrollBox_EditedLines.Length - 1
            s += ScrollBox_EditedLines(i).LineNumber.ToString + " " + _
                 ScrollBox_EditedLines(i).LifeCounter.ToString + " "
        Next
        Return s + vbCrLf
    End Function

    Friend Sub ScrollBox_ClearEditedLines()
        ReDim ScrollBox_EditedLines(-1)
    End Sub

    Friend Sub ScrollBox_AddEditedLine(ByVal line As Int32)
        Dim RemoveLinesFlag As Boolean = False
        Dim ExistingLineIndex As Integer = -1
        ' ---------------------------------------------------------------- Test if the line exists
        For i As Integer = 0 To ScrollBox_EditedLines.Length - 1
            If ScrollBox_EditedLines(i).LineNumber = line Then
                ExistingLineIndex = i
            End If
        Next
        ' ---------------------------------------------------------------- If adding a new EditedLine decrease LifeCounters
        If ExistingLineIndex = -1 Then
            For i As Integer = 0 To ScrollBox_EditedLines.Length - 1
                ScrollBox_EditedLines(i).LifeCounter -= 1
                If ScrollBox_EditedLines(i).LifeCounter <= 0 Then
                    RemoveLinesFlag = True
                End If
            Next
        End If
        ' ---------------------------------------------------------------- LifeCounter = 10 for the existing or new line 
        If ExistingLineIndex <> -1 Then
            ScrollBox_EditedLines(ExistingLineIndex).LifeCounter = 10
        Else
            ReDim Preserve ScrollBox_EditedLines(UBound(ScrollBox_EditedLines) + 1)
            ScrollBox_EditedLines(UBound(ScrollBox_EditedLines)).LineNumber = line
            ScrollBox_EditedLines(UBound(ScrollBox_EditedLines)).LifeCounter = 10
        End If
        ' ---------------------------------------------------------------- Remove ZeroLife lines
        If RemoveLinesFlag Then
            ScrollBox_RemoveEditedLinesWithZeroLife()
        End If
    End Sub

    Friend Sub ScrollBox_RemoveEditedLinesWithZeroLife()
        Dim i As Int32 = 0
        While i < ScrollBox_EditedLines.Length - 1
            If ScrollBox_EditedLines(i).LifeCounter <= 0 Then
                For j As Integer = i To ScrollBox_EditedLines.Length - 2
                    ScrollBox_EditedLines(j) = ScrollBox_EditedLines(j + 1)
                Next
                ReDim Preserve ScrollBox_EditedLines(ScrollBox_EditedLines.Length - 2)
                i -= 1
            End If
            i += 1
        End While
    End Sub

    Friend Sub ScrollBox_AddEditedLinesInfo()
        If LoadingProgram Then Return
        Dim nlines As Int32 = RTB_Lines.Length
        For Each el As ScrollBox_EditedLine In ScrollBox_EditedLines
            Dim n As Int32 = el.LineNumber
            If n < 0 Or n >= nlines Then Continue For
            Dim y As Int32 = ScrollBox.Height * n \ nlines
            Dim alpha As Int32 = Math.Min(Math.Max(el.LifeCounter * 25, 0), 255)
            Dim br1 As New SolidBrush(Color.FromArgb(alpha, 0, 50, 250))
            ScrollBox_Graphics.FillEllipse(br1, 7, y - 3, 8, 7)
            RTB.HilightEditedLine(n, br1)
        Next
    End Sub


    ' ===========================================================================================
    '  SCROLL BOX - BOOKMARKS
    ' ===========================================================================================
    Private ScrollBox_BookmarkLines(-1) As Int32

    Private Sub ScrollBox_BookmarkToggle()
        ScrollBox_ToggleBookmarkLine(RTB.GetFirstSelectedLine)
        ScrollBox_Paint()
        RTB.TextMustBeSaved = True
        RTB.Refresh()
        RTB.Focus()
    End Sub

    Private Sub ScrollBox_BookmarkDelete()
        If MessageBox.Show("About to clear all Bookmarks." + vbCrLf + vbCrLf + "Are you sure ?", _
                           "Message from Automation", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            ScrollBox_ClearBookmarkLines()
            ScrollBox_Paint()
            RTB.TextMustBeSaved = True
            RTB.Refresh()
        End If
    End Sub

    Friend Sub ScrollBox_AddBookmarkLinesFromFile(ByVal s As String)
        s = s.Trim
        If s = "" Then
            ReDim ScrollBox_BookmarkLines(-1)
            Return
        End If
        Dim sa() As String = s.Split(" "c)
        ' ------------------------------------------------ add bookmarks
        ReDim ScrollBox_BookmarkLines(sa.Length - 1)
        For i As Int32 = 0 To sa.Length - 1
            ScrollBox_BookmarkLines(i) = CInt(Val(sa(i)))
        Next
        ' ------------------------------------------------ remove bookmarks after the last line
        For Each n As Int32 In ScrollBox_BookmarkLines
            If n < 0 Or n >= RTB_Lines.Length Then
                ScrollBox_ToggleBookmarkLine(n)
            End If
        Next
    End Sub

    Friend Function ScrollBox_BookmarkLinesToString() As String
        Dim s As String = vbCrLf + "'BOOKMARKS "
        For i As Int32 = 0 To ScrollBox_BookmarkLines.Length - 1
            s += ScrollBox_BookmarkLines(i).ToString + " "
        Next
        Return s + vbCrLf
    End Function

    Friend Sub ScrollBox_ClearBookmarkLines()
        ReDim ScrollBox_BookmarkLines(-1)
    End Sub

    Friend Sub ScrollBox_ToggleBookmarkLine(ByVal line As Int32)
        For i As Integer = 0 To ScrollBox_BookmarkLines.Length - 1
            If ScrollBox_BookmarkLines(i) = line Then
                For j As Integer = i To ScrollBox_BookmarkLines.Length - 2
                    ScrollBox_BookmarkLines(j) = ScrollBox_BookmarkLines(j + 1)
                Next
                ReDim Preserve ScrollBox_BookmarkLines(ScrollBox_BookmarkLines.Length - 2)
                Return
            End If
        Next
        ReDim Preserve ScrollBox_BookmarkLines(UBound(ScrollBox_BookmarkLines) + 1)
        ScrollBox_BookmarkLines(UBound(ScrollBox_BookmarkLines)) = line
        Array.Sort(ScrollBox_BookmarkLines)
        Array.Reverse(ScrollBox_BookmarkLines)
    End Sub

    Private BookmarkBrush As New SolidBrush(Color.FromArgb(255, 200, 220, 255))
    Friend Sub ScrollBox_AddBookMarkLinesInfo()
        If LoadingProgram Then Return
        Dim nlines As Int32 = RTB_Lines.Length
        For Each n As Int32 In ScrollBox_BookmarkLines
            If n < 0 Or n >= nlines Then Continue For
            Dim y As Int32 = ScrollBox.Height * n \ nlines
            ScrollBox_Graphics.FillEllipse(BookmarkBrush, 0, y - 3, 16, 8)
            ScrollBox_Graphics.DrawEllipse(Pens.Gray, 0, y - 3, 16, 8)
            RTB.HilightBookmarkedLine(n, BookmarkBrush)
        Next
    End Sub

    ' ===========================================================================================
    '  SCROLL BOX - Correct EDITED LINES INFO and BOOKMARKS
    ' ===========================================================================================
    Friend Sub ScrollBox_CorrectEditedLinesAndBookmarks(ByVal StartLine As Int32, _
                                                        ByVal NumLines As Int32, _
                                                        ByVal LastLine As Int32)
        ' --------------------------------------------------------------------- Set to -1 the indices of deleted Edited Lines
        If NumLines < 0 Then
            For i As Int32 = 0 To ScrollBox_EditedLines.Length - 1
                If ScrollBox_EditedLines(i).LineNumber >= StartLine And _
                   ScrollBox_EditedLines(i).LineNumber <= StartLine + Math.Abs(NumLines) Then
                    ScrollBox_EditedLines(i).LineNumber = -1
                End If
            Next
        End If
        ' --------------------------------------------------------------------- Correct EditedLines indices
        For i As Int32 = 0 To ScrollBox_EditedLines.Length - 1
            If ScrollBox_EditedLines(i).LineNumber >= StartLine Then
                ScrollBox_EditedLines(i).LineNumber += NumLines
            End If
        Next
        ' --------------------------------------------------------------------- Set to -1 the indices of deleted BookMark lines
        If NumLines < 0 Then
            For i As Int32 = 0 To ScrollBox_BookmarkLines.Length - 1
                If ScrollBox_BookmarkLines(i) >= StartLine And _
                   ScrollBox_BookmarkLines(i) <= StartLine + Math.Abs(NumLines) Then
                    ScrollBox_BookmarkLines(i) = -1
                End If
            Next
        End If
        ' --------------------------------------------------------------------- Correct BookMark indices
        For i As Int32 = 0 To ScrollBox_BookmarkLines.Length - 1
            If ScrollBox_BookmarkLines(i) >= StartLine Then
                ScrollBox_BookmarkLines(i) += NumLines
            End If
        Next
    End Sub

End Class
